#pragma once

#include "IDrawable.h"
#include "ISelectCommand.h"

class Button: public IDrawable {
public:
    void set();  ///@todo
    void select();  ///@todo
    void unselect();  ///@todo
    bool is_selected();  ///@todo
    void is_position_in(sf::Vector2f pos);  ///@todo
    void push() const;
    void draw_into(sf::RenderWindow& window) const override;  ///@todo
private:
    sf::Text m_text;
    bool m_is_selected = false;
    sf::RectangleShape m_rectangle;
    std::unique_ptr<ISelectCommand> m_ptr_command;
};