#pragma once

#include <States/IState.h>

class Application: public IStateManager{
private:
    void set_next_state(std::unique_ptr<IState>&& ptr_state) override;
    void apply_differ_state_change() noexcept;
private:
    std::unique_ptr<IState> m_ptr_state_next;
    std::unique_ptr<IState> m_ptr_state_current;
public:
    Application(); ///@todo
    int run();
};